"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ObjectStack = void 0;
var upper_case_first_1 = require("upper-case-first");
var ObjectStack = /** @class */ (function () {
    function ObjectStack(type, field, parent, isFragment) {
        if (isFragment === void 0) { isFragment = false; }
        this.type = type;
        this.field = field;
        this.parent = parent;
        this.isFragment = isFragment;
        this.seenFields = new Set();
    }
    Object.defineProperty(ObjectStack.prototype, "name", {
        get: function () {
            var _a = this, parent = _a.parent, field = _a.field, isFragment = _a.isFragment, type = _a.type;
            var fieldName = field ? upper_case_first_1.upperCaseFirst(field.responseName) : '';
            var name = "" + (parent ? parent.name : '') + fieldName;
            return isFragment ? "" + name + (type ? type.name : 'Other') : name;
        },
        enumerable: false,
        configurable: true
    });
    ObjectStack.prototype.nested = function (field, type) {
        return new ObjectStack(type, field, this);
    };
    ObjectStack.prototype.fragment = function (type) {
        return new ObjectStack(type, this.field, this.parent, true);
    };
    ObjectStack.prototype.sawField = function (field) {
        this.seenFields.add(field.responseName);
    };
    ObjectStack.prototype.hasSeenField = function (field) {
        return this.seenFields.has(field.responseName);
    };
    return ObjectStack;
}());
exports.ObjectStack = ObjectStack;
